Bug 803342

Summary: Can't show boot menu using modifier keys
Product: [Fedora] Fedora Reporter: Kamil Páral <kparal>
Component: grub2Assignee: Peter Jones <pjones>
Status: NEW --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: a.vanloon, bcl, dennis, j.orti.alcaine, mads, pjones
Target Milestone: ---Keywords: FutureFeature
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 757487    

Description Kamil Páral 2012-03-14 09:46:00 EDT
Description of problem:
If you set timeout=0 in grub.cfg, you are not shown the boot menu. However you can still display it (e.g. when you need recovery mode) by holding SHIFT during grub initialization. Unfortunately this doesn't work in Fedora. It works in other distributions, like Ubuntu.

I vaguely remember I read something that stated that this shift key support is optional and must compiled in as a module. I don't know that for sure. But I know it should work and it doesn't.

Please add shift support to grub, it's quite essential. There's no other way how to access the menu if you set timeout=0. If your default boot menu item breaks, you're in trouble.

Version-Release number of selected component (if applicable):
grub2-1.99-14.fc17.i686

How reproducible:
always

Steps to Reproduce:
1. set timeout=0 in grub.cfg
2. try to interrupt boot by holding shift
Comment 1 Mads Kiilerich 2012-04-17 19:09:01 EDT
The grub.cfg generated by the grub2-mkconfig shell script from a-very-hot-place do not use any modifier detection.

It is possible to use http://www.gnu.org/software/grub/manual/grub.html#keystatus to implement it.

If you manually edit grub.cfg in such a way that other manual changes are necessary then you are on your own.

Instead I would recommend /etc/default/grub with something like
GRUB_HIDDEN_TIMEOUT=3
GRUB_HIDDEN_TIMEOUT_QUIET=true

- but you are right, https://fedoraproject.org/wiki/Features/Grub2 is still not at 100%, and Fedora grub2 do still not give a user experience that matches grub legacy.
Comment 2 Mads Kiilerich 2012-11-16 09:27:44 EST
On my custom live usb I now replace
  set timeout=...
with
  if keystatus --ctrl
  then set timeout=-1
  else set timeout=0
  fi

That gives a quiet instant boot unless I press ctrl.

IMO that is a nice fit for EFI systems with a boot menu in the firmware.
Comment 3 Fedora End Of Life 2013-04-03 13:03:39 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 4 Fedora End Of Life 2015-01-09 12:04:11 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Kamil Páral 2015-01-13 09:08:42 EST
I tried it with Fedora 21, and on my system pressing or holding the modifier keys during boot is not fully reliable. Still, it would be nice if grub supported this, so that interested users could easily configure it (in /etc/default/grub, not in the final grub2.cfg file, which should not be modified by hand, because it gets overwritten).